
require 'rexml/document'

$inputFilename = "font.xml"


#  Takes "Generic XML" as output by TexturePacker
#  Outputs equivalent FNT file for use with cocos2d

#  Make sure to disable "allow rotation" in TexturePacker before you export.


def characterByName(characterName)
    case characterName
        when "add" 
            "+"
        when "ampersand" 
            "&"
        when "apostrophe" 
            "'"
        when "asterisk" 
            "*"
        when "multiply" 
            "×"
        when "at" 
            "@"
        when "backslash" 
            "\\"
        when "bracket1" 
            "("
        when "bracket2" 
            ")"
        when "caret" 
            "^"
        when "colon" 
            ":"
        when "comma" 
            ","
        when "dollar" 
            "$"
        when "equals" 
            "="
        when "euro" 
            "^"
        when "exclamation" 
            "!"
        when "forwardslash" 
            "/"
        when "hyphen" 
            "-"
        when "leftbracket" 
            "("
        when "minus" 
            "-"
        when "percent" 
            "%"
        when "period" 
            "."
        when "plus" 
            "+"
        when "question" 
            "?"
        when "quote" 
            "\""
        when "rightbracket" 
            ")"
        when "semicolon" 
            ";"
        when "slash" 
            "/"
        when "star" 
            "*"
        when "sterling" 
            "£"
        when "stop" 
            "."
        when "yen" 
            "|"
        else characterName.upcase
    end
end

def processCharacter(characterXML, font, spacing)
    characterName = characterXML.attributes['n']
    characterPrefixToRemove = font + "-"
    
    return if !characterName.start_with? characterPrefixToRemove
    
    characterName = characterName[characterPrefixToRemove.length .. -1]
    character = characterByName(characterName)
    ascii = character[0].ord
    puts character
    
    xAdvance = characterXML.attributes['w'].to_i
    xAdvance += spacing
    
    ascii = 163 if character == "£"

    specialCharactersMultiplier = 1

    case font
        when "small" 
            specialCharactersMultiplier = 1
        when "smalloutline" 
            specialCharactersMultiplier = 1
        when "medium" 
            specialCharactersMultiplier = 1.25
        when "mediumoutline" 
            specialCharactersMultiplier = 1.25
        when "large" 
            specialCharactersMultiplier = 2
        when "largeoutline" 
            specialCharactersMultiplier = 2
        when "xlarge" 
            specialCharactersMultiplier = 3
        when "xlargeoutline" 
            specialCharactersMultiplier = 3
    end

    customOffsetY = Integer((characterXML.attributes['oY'] || "0"))
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'À'
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'Á'
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'Â'
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'Ã'
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'Ä'
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'Å'
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'Æ'
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'Ç'
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'È'
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'É'
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'Ê'
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'Ë'
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'Ì'
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'Í'
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'Î'
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'Ï'
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'Ð'
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'Ñ'
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'Ò'
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'Ó'
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'Ô'
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'Õ'
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'Ö'
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'Ø'
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'Ù'
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'Ú'
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'Û'
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'Ü'
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'Ý'
    customOffsetY = customOffsetY - 0 * specialCharactersMultiplier if character == 'ß'
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'Œ'
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'Š'
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'Ÿ'
    customOffsetY = customOffsetY - 4 * specialCharactersMultiplier if character == 'Ž'

    if font == "large" and character == 'Ä'
        customOffsetY = customOffsetY + 2
    end


    if font == "xlarge" and character == 'Ç'
        customOffsetY = customOffsetY + 3 * specialCharactersMultiplier
    end

    if font == "largeoutline" and character == 'Ä'
        customOffsetY = customOffsetY + 2
    end

    if character == '™'
        customOffsetY = customOffsetY - 4 * specialCharactersMultiplier
    end

    if character == '©'
        customOffsetY = customOffsetY - 4 * specialCharactersMultiplier
    end

    customOffsetX = Integer((characterXML.attributes['oX'] || "0"))

    customOffsetX = customOffsetX - 1 * specialCharactersMultiplier if character == 'Î'
    customOffsetX = customOffsetX - 3 * specialCharactersMultiplier if character == 'Í'
    customOffsetX = customOffsetX - 3 * specialCharactersMultiplier if character == 'Ì'

    if font == "large" and character == 'Í'
        customOffsetX = customOffsetX + 2
    end

    if font == "xlarge" and character == 'Í'
        customOffsetX = customOffsetX + 8
        customOffsetY = customOffsetY + 2
    end

    if font == "largeoutline" and character == 'Í'
        customOffsetX = customOffsetX + 2
    end
    
    line = "char id=" + ascii.to_s
    line += " x=" + characterXML.attributes['x']
    line += " y=" + characterXML.attributes['y']
    line += " width=" + characterXML.attributes['w']
    line += " height=" + characterXML.attributes['h']
    line += " xoffset=" + customOffsetX.to_s
    line += " yoffset=" + customOffsetY.to_s
    line += " xadvance=" + xAdvance.to_s
    line += " page=0 chnl=0"
end

def processFont(xml, font)
    outputFilename = "font-#{font}.fnt"
    output = File.new(outputFilename, "w")
    imageFilename = xml.elements["TextureAtlas/@imagePath"]
    
    spaceWidth = 8
    spacing = 1
    lineHeight = 20
    
    case font
        when "small" 
            spacing = 1
        when "smalloutline" 
            spacing = -3
        when "medium" 
            spacing = 1
        when "mediumoutline" 
            spacing = -2
        when "large" 
            spacing = 1
        when "largeoutline" 
            spacing = -2
        when "xlarge" 
            spacing = 2
        when "xlargeoutline" 
            spacing = 0
    end
    
    lineHeight = 15 if font.start_with? "small"
    lineHeight = 26 if font.start_with? "large"
    lineHeight = 42 if font == "score"
    lineHeight = 44 if font.start_with? "xlarge"
    
    output.puts "info face=\"#{$inputFilename}\" size=\"16\" " \
                "bold=0 italic=0 charset=\"\" unicode=1 " \
                "stretchH=100 smooth=0 aa=0 padding=0,0,0,0 spacing=0,0"
    output.puts "common lineHeight=#{lineHeight} base=#{lineHeight} " \
                "scaleW=256 scaleH=256 pages=1 packed=0"
    output.puts "page id=0 file=\"#{imageFilename}\""
    
    characters = []
    characters.push "char id=32 x=0 y=0 width=0 height=0 " \
                    "xoffset=0 yoffset=0 xadvance=#{spaceWidth-1} " \
                    "page=0 chnl=0";
    
    xml.elements.each('TextureAtlas/sprite') {|e|
        characterLine = processCharacter(e, font, spacing)
        characters.push characterLine if characterLine
    }
    characters.sort!
    
    output.puts "chars count=" + characters.length.to_s
    characters.each {|a| output.puts a}
    
    kernings = []
    if font.start_with? "medium"
        kernings.push "kerning first=#{'P'[0].ord} second=#{'A'[0].ord} amount=-1"
    end
    
    if kernings.count > 0
        output.puts "kernings count=#{kernings.count}"
        kernings.each {|k| output.puts k}
    end
end

def process()
    inputString = File.open($inputFilename, "r").read
    inputXML = REXML::Document.new(inputString)
    
    fonts = []
    inputXML.elements.each('TextureAtlas/sprite') {|e|
        fonts.push e.attributes['n'].split("-")[0]
    }
    fonts.uniq!
    
    fonts.each {|font| processFont(inputXML, font)}
end

process
